unit UnitBogenschnitt3D;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ToolWin, ComCtrls,math, ExtCtrls;

const RhoG=200/Pi;

type
   TPunkt=Record
    PktNr:String;
    X,Y,Z,v:Double;
  end;
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Label2: TLabel;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Edit2: TEdit;
    StringGrid1: TStringGrid;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    Button3: TButton;
    Button2: TButton;
    StatusBar1: TStatusBar;
    ToolBar1: TToolBar;
    Memo1: TMemo;
    RadioGroup1: TRadioGroup;
    Button4: TButton;
    procedure Button4Click(Sender: TObject);
    procedure Edit2DblClick(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  P:Array of Tpunkt;
implementation


{$R *.dfm}
function GetStr(var s:String):String;
var i:Integer;
begin
  Result:='';
  While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  i:=pos(' ',s);
  if i>0 then
  begin
    Result:=copy(s,1,i-1);
    delete(s,1,i-1);
    s:=Trim(s);//While (length(s)>0) and (s[1]=' ') do delete(s,1,1);
  end
  else
  begin
    Result:=s;
    s:='';
  end;
end;

function GetFloat(var Satz:String):Real;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;

  i:=Pos(',',S);
  if i>0 then
  begin
   S[i]:='.';
  end;

  try
   Result:=StrToFloat(s);
  except
    on EConvertError do
    begin
      Showmessage('Fehler: '+s+' ist kein gltiger Real Wert.');
      Showmessage('-> '+Satz);
      Result:=0;
    end;
  end;

end;

function GetInt(var Satz:String):Integer;
var i:integer;
    s:string;
begin
  S:='';
  While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  i:=pos(' ',Satz);
  if i>0 then
  begin
    s:=copy(satz,1,i-1);
    delete(satz,1,i-1);
    While (length(satz)>0) and (Satz[1]=' ') do delete(satz,1,1);
  end
  else
  begin
    if satz>'' then s:=Satz;
    satz:='';
  end;

  try
   Result:=StrToInt(s);
  except
    on EConvertError do
    begin
      Showmessage('Fehler: '+s+' ist kein gltiger Integer Wert.');
      Showmessage('-> '+Satz);
      Result:=0;
    end;
  end;

end;

function sgn(x:real):integer;
begin
  sgn:=0;
  if x<0 then sgn:=-1
  else if x>0 then sgn:=1;
end;

Procedure RIWI(dy,DX : Double;var S,T:Double);
Begin
  If DX = 0 Then T := sgn(dy)*Pi/2
  Else T := ArcTan(dy/DX);
  If DX < 0 Then T := T+Pi;
  If T < 0 Then T := T+Pi+Pi;
  S := Sqrt(dy*dy+DX*DX);
  If (DX = 0) And (dy = 0) Then T := 0;
End;

Function Kugelmittelpunkt(var P:Array of TPunkt;R:Double;PolarKoo:Boolean):Integer;
Type
  TVektor=Array of Double;
  T3Vektor=Array[1..3] of Double;
  TMatrix=Array of Array of Double;
var
  v1,v2,v3,X0,dx:T3Vektor;
  L,M,sv:TVektor;
  A,N,B:TMatrix;
  i,j,k,ia,ib,ic,iter:integer;
  sum,sumx,sumy,S,T,S0,T0,h:Double;


function Inverse(var S:TMatrix;U:Integer):boolean;
var j,k,l:Integer;
begin
  Inverse:=True;
  (* Invertieren *)
  for j:=1 to U do
  begin
    If abs(S[j,j])<1E-32 then
    begin
      Inverse:=False;
      Exit;
    end;
    S[j,j]:=1/S[j,j];
    for l:=1 to U do
      if l<>j then
      begin
        S[l,j]:=-S[j,j]*S[l,j];
        for k:=1 to U do
        if k<>J then S[l,k]:=S[l,j]*S[j,k]+S[l,k];
      end;
    for k:=1 to U do
      If k<>J then S[j,k]:=S[j,j]*S[j,k];
  end;
end;

Procedure Kugelaus4Punkten(var P:Array of TPunkt;var XM,YM,ZM,R:Double);
var
  X,L:TVektor;
  A:TMatrix;
  i,j:integer;
begin
  R:=0;XM:=0;YM:=0;ZM:=0;
  If High(P)<4 then exit;
  setlength(A,5,5);
  setlength(L,5);
  setlength(X,5);

  for i:=1 to 4 do
  begin
    A[i,1]:=1;
    A[i,2]:=P[i].X-P[1].X;
    A[i,3]:=P[i].Y-P[1].Y;
    A[i,4]:=P[i].Z-P[1].Z;
    L[i]:=(sqr(P[i].X-P[1].X)+sqr(P[i].Y-P[1].Y)+sqr(P[i].Z-P[1].Z));
  end;
  if not Inverse(A,4) then exit;
  For i:=1 to 4 do X[i]:=0;
  For i:=1 to 4 do
    For j:=1 to 4 do X[i]:=X[i]+A[i,j]*L[j];
  XM:=X[2]/2;YM:=X[3]/2;ZM:=X[4]/2;
  R:=SQRT(XM*XM+YM*YM+ZM*ZM-X[1]);
  XM:=XM+P[1].X;YM:=YM+P[1].Y;ZM:=ZM+P[1].Z;
end;

begin
  //Arrays Initialisieren
  Result:=-1;
  if High(P)<3 then exit;
  setlength(A,High(P)+1,4);
  Setlength(L,High(P)+1);
  Setlength(M,High(P)+1);
  Setlength(N,4,4);
  FillChar(X0,SizeOf(X0),0);
  P[0].X:=0;P[0].Y:=0;P[0].Z:=0;
  If PolarKoo then
  begin
    for i:=1 to high(P) do
    begin
      S:=p[i].X;
      T:=P[i].Y;
      P[i].X:=S*cos(T/RHOG);
      P[i].Y:=S*sin(T/RHOG);
    end;
  end;
  // suche nach flchengrssten Dreieck , lngste Grundlinie
  sum:=0;ia:=0;ib:=0;
  for i:=1 to high(P) do
    for j:=i+1 to high(P) do
    begin
      S0:=sqr(P[j].X-P[i].X)+sqr(P[j].Y-P[i].Y);
      if S0>sum then
      begin
        sum:=S0;
        ia:=i;ib:=j;
      end;
    end;
  sum:=0;ic:=0;
  RIWI(P[ib].Y-P[ia].Y,P[ib].x-P[ia].X,S0,T0);
  //  Suche grsste Dreieckshhe ber Grundlinie
  for i:=1 to high(P) do
  begin
    RIWI(P[i].Y-P[ia].Y,P[i].X-P[ia].x,S,T);
    h:=abs(S*sin(T-T0));
    if (h>sum) and (i<>ib)  then
    begin
      sum:=h;ic:=i;
    end;
  end;
  if ic=0 then
  begin
    result:=-2;
    exit;
  end;
  RIWI(P[ic].Y-P[ia].Y,P[ic].X-P[ia].x,S,T);

  // Umkreismittelpunkt im Dreieck abc berechnen
  v1[1]:=P[ib].X-P[ia].X;
  v1[2]:=P[ib].Y-P[ia].Y;
  v1[3]:=P[ib].Z-P[ia].Z;

  v2[1]:=P[ic].X-P[ia].X;
  v2[2]:=P[ic].Y-P[ia].Y;
  v2[3]:=P[ic].Z-P[ia].Z;
  // Nomalenvektor Kreuzprodukt v1xv2
  v3[1]:=v1[2]*v2[3]-v1[3]*v2[2];
  v3[2]:=v1[3]*v2[1]-v1[1]*v2[3];
  v3[3]:=v1[1]*v2[2]-v1[2]*v2[1];
  sum:=0;
  for i:=1 to 3 do sum:=sum+v3[i]*v3[i];
  sum:=Sqrt(sum);
  if (sum<=0) or (R=0)  then
  begin
    Result:=-3;
    Exit;
  end;

  for i:=1 to 3 do v3[i]:=v3[i]/Sum;
  A[1,1]:=2*(P[ib].X-P[ia].X);A[1,2]:=2*(P[ib].Y-P[ia].Y);
  A[2,1]:=2*(P[ic].X-P[ia].X);A[2,2]:=2*(P[ic].Y-P[ia].Y);
  if not Inverse(A,2) then
  begin
    Result:=-4;
    exit;
  end;

  L[1]:=sqr(P[ib].X)-sqr(P[ia].X)+sqr(P[ib].Y)-sqr(P[ia].Y);
  L[2]:=sqr(P[ic].X)-sqr(P[ia].X)+sqr(P[ic].Y)-sqr(P[ia].Y);
  for i:=1 to 2 do
  begin
    x0[i]:=0;
    for j:=1 to 2 do x0[i]:=x0[i]+A[i,j]*L[j];
  end;
  // Abstand Umkreismittelpunkt Kugelmittelunkt
  sum:=(R*R-sqr(x0[1]-P[ia].X)-sqr(x0[2]-P[ia].Y));
  if sum<=0 then
  begin
    Result:=-5;
    exit
  end
  else sum:=sqrt(sum);

  x0[3]:=(P[ia].Z+P[ib].Z+P[ic].Z)/3;
  // Kugelmittelpunkt berechnen
  if v3[3]<0 then sum:=-sum;

  for i:=1 to 3 do x0[i]:=x0[i]-sum*v3[i];
  Form1.Memo1.lines.add('Kugelzentrierung Punkt '+P[0].PKtNR);
  Form1.Memo1.Lines.Add(
  format('3 Punkt Umkreis Lsung      XM %10.3f YM %10.3f, ZM %10.3f, R %5.3f',[X0[1],X0[2],X0[3],R]));
  if High(P)>3 then
  begin
    Kugelaus4Punkten(P,X0[1],X0[2],X0[3],sum);
    Form1.Memo1.Lines.Add(
    format('Analytische 4 Punkt Lsung XM %10.3f YM %10.3f, ZM %10.3f, R %5.3f',[X0[1],X0[2],X0[3],sum]));
  end;
  // Ausgleichung Arrays Nullsetzen
  for i:=0 to High(P) do
  begin
    L[i]:=0;
    for j:=0 to 3 do  A[i,j]:=0;
  end;
  for i:=0 to 3 do
  begin
    M[i]:=0;
    for j:=0 to 3 do N[i,j]:=0;
  end;
  Iter:=0;
  //repeat
  // Fehlergleichungen aufstellen
  for i:=1 to High(P) do
  begin
    A[i,1]:=(x0[1]-P[i].X)/R;A[i,2]:=(X0[2]-P[i].Y)/R;A[i,3]:=(X0[3]-P[i].z)/R;
    L[i]:=sqrt(sqr(x0[1]-P[i].X)+sqr(X0[2]-P[i].Y)+sqr(X0[3]-P[i].Z))-R;
  end;
{
for i:=1 to High(P) do
     for j:=1 to 3 do
     form1.memo1.Lines.add(
      Format('A[%d,%d]=%10.6f',[i,j,A[i,j]]));
for i:=1 to High(P) do
   form1.memo1.Lines.add(
      Format('L[%d]=%10.6f',[i,L[i]]));
}
  // Normalgleichungen
  for i:=1 to 3 do
    for j:=1 to 3 do
      for k:=1 to High(P) do N[i,j]:=N[i,j]+A[k,i]*A[k,j];
{
  for i:=1 to 3 do
     for j:=i to 3 do form1.memo1.Lines.add(
      Format('N[%d,%d]=%10.6f',[i,j,N[i,j]]));

}
  If not Inverse(N,3) then
  begin
   Result:=-6;
   Exit;
  end;
  for i:=1 to 3 do
    for j:=1 to High(P) do M[i]:=M[i]+A[j,i]*L[j];
  // Unbekanntenvektor
  FillChar(dx,Sizeof(dx),0);
  for i:=1 to 3 do
    for j:=1 to 3 do dx[i]:=dx[i]+N[i,j]*M[j];
  // Mittelpunktkorrektur
  for i:=1 to 3 do x0[i]:=x0[i]-dx[i];
  // Fehlerrrechnung
  sum:=0;
  for i:=1 to High(P) do
  begin
    P[i].V:=sqrt(sqr(x0[1]-P[i].X)+sqr(X0[2]-P[i].Y)+sqr(X0[3]-P[i].Z))-R;
    sum:=sum+sqr(P[i].v);
  end;
  // m0
  if High(P)>3 then sum:=sqrt(sum/(high(P)-3)) else sum:=0;
  //m dx
  For i:=1 to 3 do v1[i]:=sum*sqrt(N[i,i]);

  // Result setzen
  P[0].X:=X0[1];
  P[0].Y:=X0[2];
  P[0].Z:=X0[3];
  Result:=0;
  // Qvv berechnen
  setlength(Sv,High(P)+1);
  for i:=1 to high(P) do
  begin
    sv[i]:=0;
    for j:=1 to 3 do
      for k:=1 to 3 do
        sv[i]:=sv[i]+A[i,k]*N[j,k]*A[i,j];
  end;
  // NV berechnen
  for i:=1 to high(P) do  if sum>0 then sv[i]:=P[i].v/(sum*sqrt(sv[i])) else sv[i]:=0;

  inc(iter);
  Form1.Memo1.Lines.Add('Ausgleichung');
{
  for i:=1 to 3 do
     for j:=i to 3 do form1.memo1.Lines.add(
     format('N[%d,%d]=%10.6f',[i,j,N[i,j]]));
}
  Form1.Memo1.Lines.Add(
  format('dx=%5.4f dy=%5.4f, dZ=%5.4f',[dx[1],dx[2],dx[3]]));
  if sum>0 then Form1.Memo1.Lines.Add(
    format('m0=%5.4f mX(P0)=%4.3f, mY(P0)=%4.3f, mZ(P0)=%4.3f',[sum,v1[1],v1[2],v1[3]]));
  Form1.Memo1.Lines.Add(
  format('%16s XM %5.4f YM %4.3f, ZM %4.3f',[P[0].PktNr,X0[1],X0[2],X0[3]]));
  for i:=1 to high(P) do
  if sum>0 then Form1.Memo1.Lines.Add(format('%16s, vR %5.4f NV %4.1f',[P[i].PktNr,P[i].v,sv[i]]))
  else Form1.Memo1.Lines.Add(format('%16s, vR %5.4f',[P[i].PktNr,P[i].v]));

  //until (abs(dx[1])+ abs(dx[2])+ abs(dx[3])<5E-3) or (iter=10);
  if Polarkoo then
  begin
    for i:=0 to high(P) do
    begin
      RIWI(P[i].Y,P[i].X,S,T);
      P[i].X:=S;P[i].Y:=T*RhoG;
      P[i].Z:=arctan((P[i].Z)/S)*RhoG;
    end;
  end;
end;



procedure TForm1.Button1Click(Sender: TObject);
var i:Integer;
begin
  with stringgrid1 do
  begin
    setlength(P,RowCount-1);
    for i:=1 to High(P) do
    begin
      P[i].X:=StrTofloat(cells[1,i+1]);
      P[i].Y:=StrTofloat(cells[2,i+1]);
      P[i].Z:=StrTofloat(cells[3,i+1]);
      P[i].v:=0;
    end;
    Kugelmittelpunkt(P,StrToFloat(Edit1.Text),False);
    for i:=0 to High(P) do
    begin
      Cells[0,i+1]:=Format('P%2d',[i]);
      Cells[1,i+1]:=format('%12.3f',[P[i].X]);
      Cells[2,i+1]:=format('%12.3f',[P[i].Y]);
      Cells[3,i+1]:=format('%12.3f',[P[i].Z]);
      If i>0 then Cells[4,i+1]:=format('%12.4f',[P[i].v]);
    end;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
var f,f1:textfile;
  Nr:integer;
  hz,zd,di,st,t,x,y,z:Double;
begin
  assignfile(f,'d:\geoe\testverdeckt\test2.beb');
  reset(f);
  assignfile(f1,'d:\geoe\testverdeckt\test2.Kor');
  rewrite(f1);

  while not eof(f) do
  begin
    Readln(f,Nr,hz,zd,di,t);
    z:=100+di*cos(zd/RhoG);
    st:=DI*sin(ZD/RhoG);
    x:=100+ST*cos(HZ/RhoG);
    y:=100+st*sin(Hz/RhoG);
    writeln(f1,format('%5d %12.3f %12.3f %12.3f %10.3f',[NR,X,Y,Z,t]));
  end;
  Closefile(f);
  Closefile(f1);
end;

procedure TForm1.Button3Click(Sender: TObject);
var f:textfile;
    t:Double;
    Nr:longword;
    i:integer;
    Polar:boolean;

begin
  assignfile(f,Edit2.Text);
  reset(f);
  setlength(P,1);
    Form1.Memo1.Lines.Clear;

  t:=0;
  while not eof(f) do
  begin
    setlength(P,length(P)+1);
    i:=high(P);
    with P[high(P)] do
    begin
      case Radiogroup1.ItemIndex of
      0:readln(f,Nr,x,y,z,t);
      1:readln(f,Nr,Y,X,z,t);
      2,3,5,6:readln(f,Nr,Y,X,Z,t);
      4,7:readln(f,Nr,Y,z,X,t);
      end;
      P[i].PktNr:=IntTostr(Nr);
    end;
  end;
  case Radiogroup1.ItemIndex of
  0,1:Polar:=False
  else Polar:=True;
  end;

  for i:=1 to high(P) do

  case Radiogroup1.ItemIndex of
  3,4:
    begin
      p[i].Z:=P[i].X*cot(P[i].Z/RhoG);
    end;
  6,7:
    begin
      P[i].Z:=P[i].X*cos(P[i].Z/RhoG);
    end;
  end;

  closefile(f);
  Edit1.text:=Floattostr(t);
  If Kugelmittelpunkt(P,t,Polar) >0 then Showmessage('Kugelmittelnpunkt Fehler');
  StringGrid1.RowCount:=high(P)+2;
  StringGrid1.ColCount:=5;
  StringgRid1.Cells[0,0]:='Punkt';
  Case RadioGroup1.Itemindex of
  0:Begin
     StringgRid1.Cells[1,0]:='X';
     StringgRid1.Cells[2,0]:='Y';
     StringgRid1.Cells[3,0]:='Hhe';
  end;
  1:Begin
     StringgRid1.Cells[1,0]:='Y';
     StringgRid1.Cells[2,0]:='X';
     StringgRid1.Cells[3,0]:='Hhe';
  end;
  2:Begin
     StringgRid1.Cells[1,0]:='S';
     StringgRid1.Cells[2,0]:='Ri';
     StringgRid1.Cells[3,0]:='dH';
  end;
  3,4:Begin
     StringgRid1.Cells[1,0]:='S';
     StringgRid1.Cells[2,0]:='Ri';
     StringgRid1.Cells[3,0]:='Zd';
  end;
  5:Begin
     StringgRid1.Cells[1,0]:='D';
     StringgRid1.Cells[2,0]:='Ri';
     StringgRid1.Cells[3,0]:='dH';
  end;
  6..7:Begin
     StringgRid1.Cells[1,0]:='D';
     StringgRid1.Cells[2,0]:='Ri';
     StringgRid1.Cells[3,0]:='Zd';
  end;
  end;
  StringgRid1.Cells[4,0]:='vdH';
  With Stringgrid1 do
  for i:=0 to High(P) do
  begin
    Cells[0,i+1]:=P[i].PktNr;
    Cells[1,i+1]:=format('%12.3f',[P[i].X]);
    Cells[2,i+1]:=format('%12.3f',[P[i].Y]);
    Cells[3,i+1]:=format('%12.3f',[P[i].Z]);
    if i>0 then Cells[4,i+1]:=format('%12.4f',[P[i].v]);
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
var f:Textfile;
    Sl:TStringList;
    i,ia,ie,j:Integer;
    PktDoppelt:Array of Boolean;
    S,Satz:String;
    RI,DI,ZD,RF,ST:Double;
function GetPNR(i:Integer):String;
var
  j:integer;
begin
  j:=Pos(' ',SL.Strings[i]);
  if j>0 then Result:=copy(SL.Strings[i],1,j-1)
  else Result:='';
end;


begin
  Form1.Memo1.Lines.Clear;
  SL:=TstringList.Create;
  SL.LoadFromFile(Edit2.Text);
  setlength(PktDoppelt,SL.Count+1);
  i:=0;
  repeat
    If (GetPNR(i) = GetPNR(i+1)) and (GetPNR(i)=GetPNR(i+2)) then
    begin
      ia:=i;ie:=ia+2;
      While getPNR(ie)=getPNR(ie+1) do inc(ie);
      setlength(P,0);
      setlength(P,ie-ia+2);
      for j:=ia to ie do
      begin
        Satz:=SL.Strings[j];
        P[j-ia+1].PktNR:=Getstr(Satz);
        Ri:=GetFloat(satz);
        DI:=GetFloat(satz);
        ZD:=GetFloat(satz);
        RF:=GetFloat(satz);

        P[j-ia+1].Y:=sin(RI/RhoG)*DI*sin(ZD/RhoG);
        P[j-ia+1].X:=cos(Ri/RhoG)*DI*sin(ZD/RhoG);
        P[j-ia+1].Z:=DI*cos(ZD/RHOG);
        P[j-ia+1].v:=0;
      end;
      P[0].PktNR:=P[1].PKtNR;
      If Kugelmittelpunkt(P,RF,False) >0 then Showmessage('Kugelmittelnpunkt Fehler')
      else
      begin
        for j:=ia to ie do SL.strings[j]:='*'+SL.Strings[j];
        DI:=Sqrt(sqr(P[0].X)+sqr(P[0].Y)+sqr(P[0].Z));
        RIWI(P[0].Y,P[0].X,ST,RI);
        RI:=RI*RhoG;
        ZD:=100-Arctan(P[0].Z/ST)*RhoG;
        satz:=SL.Strings[ia];
        getstr(satz);getStr(Satz);getStr(satz);getStr(satz);GetStr(satz);
        s:=format('%s  %10.4f  %10.3f  %10.4f     0.00 %s',[P[0].PktNR,RI,DI,ZD,Satz]);
        SL.Insert(ia,s);
        Memo1.lines.add('Polarkoordinaten des Kugelmittelpunktes');
        Memo1.lines.add(s);
      end;
      i:=ie;
    end;
    inc(i);
  until i>=SL.Count-3;
  S:=copy(Form1.Edit2.Text,1,length(form1.Edit2.Text)-3);
  SL.SaveToFile(S+'TXT');
  Memo1.Lines.SaveToFile(S+'LST');
  SL.Free;

end;

procedure TForm1.Edit2DblClick(Sender: TObject);
begin
  If Opendialog1.execute then Edit2.Text:=Opendialog1.FileName;
end;

procedure TForm1.FormActivate(Sender: TObject);
var i:Integer;
begin
  DecimalSeparator:='.';
  ThousandSeparator:=#0;
  DateSeparator:='.';
  ShortDateFormat:='dd.mm.yyyy';
  setlength(P,5);
  P[1].X:=802192.254;P[1].Y:=585697.677;P[1].Z:=71.443;
  P[2].X:=802192.620;P[2].Y:=585697.595;P[2].Z:=71.435;
  P[3].X:=802192.646;P[3].Y:=585697.951;P[3].Z:=71.484;
  P[4].X:=802192.316;P[4].Y:=585697.904;P[4].Z:=71.477;
  Edit1.Text:=floattostr(3.642);
  StringGrid1.RowCount:=6;
  StringGrid1.ColCount:=5;
  StringgRid1.Cells[0,0]:='Punkt';
  StringgRid1.Cells[1,0]:='X';
  StringgRid1.Cells[2,0]:='Y';
  StringgRid1.Cells[3,0]:='Z';
  StringgRid1.Cells[4,0]:='vZ';
  With Stringgrid1 do
  for i:=0 to High(P) do
  begin
    Cells[0,i+1]:=Format('P%2d',[i]);
    Cells[1,i+1]:=format('%12.3f',[P[i].X]);
    Cells[2,i+1]:=format('%12.3f',[P[i].Y]);
    Cells[3,i+1]:=format('%12.3f',[P[i].Z]);
  end;
  Kugelmittelpunkt(P,3.642,False);
  StringGrid1.RowCount:=6;
  StringGrid1.ColCount:=5;
  StringgRid1.Cells[0,0]:='Punkt';
  StringgRid1.Cells[1,0]:='X';
  StringgRid1.Cells[2,0]:='Y';
  StringgRid1.Cells[3,0]:='Z';
  StringgRid1.Cells[4,0]:='vZ';
  With Stringgrid1 do
  for i:=0 to High(P) do
  begin
    Cells[0,i+1]:=Format('P%2d',[i]);
    Cells[1,i+1]:=format('%12.3f',[P[i].X]);
    Cells[2,i+1]:=format('%12.3f',[P[i].Y]);
    Cells[3,i+1]:=format('%12.3f',[P[i].Z]);
    if i>0 then Cells[4,i+1]:=format('%12.4f',[P[i].v]);
  end;
end;

end.
